﻿using Microsoft.Data.SqlClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Newtonsoft.Json;
using System.Xml;

namespace SQL_Deleter
{
    public class ConnectionInfo
    {
        public ConnectionInfo(string connectionSql, string database, string userName, string password, bool winAutentication)
        {
            ConnectionSql = connectionSql;
            Database = database;
            UserName = userName;
            Password = password;
            WIndowsAutentication = winAutentication;
        }

        public string ConnectionSql { get; set; }
        public string Database { get; set; }
        public string UserName { get; set; }
        public string Password { get; set; }
        public bool WIndowsAutentication { get; set; }

        public void Save(string filename)
        {
            string json = JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
            File.WriteAllText(filename, json);
        }

        public static ConnectionInfo Load(string filename)
        {
            try
            {
                string json = File.ReadAllText(filename);
                return JsonConvert.DeserializeObject<ConnectionInfo>(json);
            }
            catch (Exception ex)
            {
                Console.WriteLine($"Failed to load the connection details: {ex.Message}");
                return null;
            }
        }

        public string GetConnectionString()
        {
            if (WIndowsAutentication)
            {
                return $"Data Source={ConnectionSql};Initial Catalog={Database};TrustServerCertificate=true; Integrated Security=True;";
            }
            return $"Data Source={ConnectionSql};Initial Catalog={Database};User ID={UserName};Password={Password};TrustServerCertificate=true;";
        }

        public string TestConnection()
        {
            try
            {
                using (SqlConnection connection = new SqlConnection(GetConnectionString()))
                {
                    connection.Open();
                    return null;
                }
            }
            catch (Exception ex)
            {
                return ex.Message;
            }

        }


        //public void DiscoverForeignKeys()
        //{
        //    using (SqlConnection connection = new SqlConnection(GetConnectionString()))
        //    {
        //        connection.Open();

        //        // First, get all table names
        //        string getAllTablesQuery = "SELECT TABLE_SCHEMA, TABLE_NAME FROM INFORMATION_SCHEMA.TABLES";
        //        using (SqlCommand cmd = new SqlCommand(getAllTablesQuery, connection))
        //        {
        //            SqlDataReader reader = cmd.ExecuteReader();
        //            while (reader.Read())
        //            {
        //                string schema = reader.GetString(0);
        //                string tableName = reader.GetString(1);

        //                SchemaTable.Add(new KeyValuePair<string, string>(schema, tableName));
        //                // Now, for each table, find its foreign keys

        //            }
        //            reader.Close();

        //            foreach (var kvp in SchemaTable)
        //            {
        //                DiscoverForeignKeysForTable(kvp.Key, kvp.Value, connection);
        //                AddTableStructure(kvp.Key, kvp.Value, connection);
        //            }
        //        }
        //    }
        //}

        //private void DiscoverForeignKeysForTable(string schema, string tableName, SqlConnection connection)
        //{
        //    string query = $@"
        //   SELECT 
        //        OBJECT_NAME(FKC.parent_object_id) AS ThisTable,
        //        COL_NAME(FKC.parent_object_id, FKC.parent_column_id) AS ThisColumn,
        //        OBJECT_NAME(FKC.referenced_object_id) AS RefTable,
        //        COL_NAME(FKC.referenced_object_id, FKC.referenced_column_id) AS ForeignColumn
        //    FROM 
        //        sys.foreign_keys AS FK
        //    INNER JOIN 
        //        sys.foreign_key_columns AS FKC ON FK.OBJECT_ID = FKC.constraint_object_id
        //    WHERE 
        //        OBJECT_NAME(FKC.parent_object_id) = '{tableName}'
        //";

        //    using (SqlCommand command = new SqlCommand(query, connection))
        //    {
        //        SqlDataReader reader = command.ExecuteReader();
        //        while (reader.Read())
        //        {
        //            var dbRelationship = new DBRelationship
        //            {
        //                Table = reader["ThisTable"].ToString(),
        //                ConnectedToTable = reader["RefTable"].ToString(),
        //                ForeignColumn = reader["ForeignColumn"].ToString(),
        //                Column = reader["ThisColumn"].ToString()
        //            };

        //            Relationships.Add(dbRelationship);
        //        }
        //        reader.Close();
        //    }
        //}

        //private void AddTableStructure(string schema, string tableName, SqlConnection connection)
        //{
        //    string query = $@"
        //    SELECT 
        //        C.COLUMN_NAME AS ColumnName,
        //        C.DATA_TYPE AS DataType,
        //        C.IS_NULLABLE AS IsNullable
        //    FROM 
        //        INFORMATION_SCHEMA.COLUMNS C
        //    WHERE 
        //        C.TABLE_NAME = '{tableName}'
        //";

        //    DBTables[tableName] = new List<TableColumn>();

        //    using (SqlCommand command = new SqlCommand(query, connection))
        //    {
        //        SqlDataReader reader = command.ExecuteReader();
        //        while (reader.Read())
        //        {
        //            var column = new TableColumn
        //            {
        //                Name = reader["ColumnName"].ToString(),
        //                IsNullable = reader["IsNullable"].ToString() == "YES",
        //                DataType = reader["DataType"].ToString()
        //            };

        //            DBTables[tableName].Add(column);
        //        }
        //        reader.Close();
        //    }
        //}
    }
}
