using SQLDeleter;
using System.Data.Common;

namespace SQL_Deleter
{
    public partial class Form1 : Form
    {
        private Connection _connection;
        private ConnectionObject _connectionObject;
        private ConnectionInfo _connectionInfo;
        private ConnectionObject _oldConnectionObject;

        private string currentOpenFile = null;
        public Form1()
        {
            InitializeComponent();
            saveAsToolStripMenuItem.Enabled = false;
            saveToolStripMenuItem.Enabled = false;
            reSyncToolStripMenuItem.Enabled = false;
            editConnectionToolStripMenuItem.Enabled = false;
            MainForm_Resize(null, null);
        }


        private void newToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            var form = new Connector();
            if (form.ShowDialog() == DialogResult.OK)
            {
                _connectionInfo = form.Connection;
                _connection = new Connection(_connectionInfo.GetConnectionString());
                _connectionObject = _connection.GetSyncWithDB();
                compareWithOldSync.Enabled = false;
                this.Text = "SQL Deleter";

                saveAsToolStripMenuItem.Enabled = true;
                saveToolStripMenuItem.Enabled = false;
                reSyncToolStripMenuItem.Enabled = true;
                editConnectionToolStripMenuItem.Enabled = true;
                inputBox.Enabled = true;
                outputBox.Enabled = true;
                GenerateButton.Enabled = true;
            }

        }

        private void MainForm_Resize(object sender, EventArgs e)
        {
            var half = panel1.Width / 2;
            // Adjust the button's location to keep it at the bottom-right corner
            panel1.Location = new Point(this.ClientSize.Width / 2 - half, panel1.Location.Y);
        }

        private void reSyncToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _oldConnectionObject = _connectionObject;
            _connectionObject = _connection.GetSyncWithDB();
            compareWithOldSync.Enabled = true;


        }

        private void GenerateButton_Click(object sender, EventArgs e)
        {
            outputBox.Text = _connectionObject.Generate(inputBox.Text);
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                _connectionInfo.Save(saveFileDialog1.FileName);
                _connection.Save(_connectionObject, null);
                currentOpenFile = saveFileDialog1.FileName;
                this.Text = "SQL Deleter - " + Path.GetFileName(currentOpenFile);
                saveToolStripMenuItem.Enabled = true;
            }
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                _connectionInfo = ConnectionInfo.Load(openFileDialog1.FileName);
                _connection = new Connection(_connectionInfo.GetConnectionString());
                _connectionObject = _connection.LoadLatestInserted();
                compareWithOldSync.Enabled = false;



                // _connection = Connection.Load(openFileDialog1.FileName);
                currentOpenFile = openFileDialog1.FileName;
                this.Text = "SQL Deleter - " + Path.GetFileName(currentOpenFile);

                saveAsToolStripMenuItem.Enabled = true;
                saveToolStripMenuItem.Enabled = true;
                reSyncToolStripMenuItem.Enabled = true;
                editConnectionToolStripMenuItem.Enabled = true;
                inputBox.Enabled = true;
                outputBox.Enabled = true;
                GenerateButton.Enabled = true;
            }
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            _connectionInfo.Save(currentOpenFile);
            _connection.Save(_connectionObject, null);
        }

        private void editConnectionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            var form = new Connector(_connectionInfo);
            if (form.ShowDialog() == DialogResult.OK)
            {
                _connectionInfo = form.Connection;
                _connection = new Connection(_connectionInfo.GetConnectionString());
                _connectionObject = _connection.GetSyncWithDB();
                compareWithOldSync.Enabled = false;
            }
        }

        private void GenerateAdvanceButton_Click(object sender, EventArgs e)
        {
            outputBox.Text = _connectionObject.Generate(inputBox.Text);
        }

        private void compareWithOldSync_Click(object sender, EventArgs e)
        {
            if(_connectionObject.CompareResult(_oldConnectionObject, inputBox.Text))
            {
                MessageBox.Show("The result matches");
            }
            else
            {
                MessageBox.Show("Changes has been made in DB so the results doesn't match");
            }
        }
    }
}
